align      = require "../../../core/methods/font/align.coffee"
decoration = require "../../../core/methods/font/decoration.coffee"
family     = require "../../../core/methods/font/family.coffee"
filter     = require "../../../core/methods/filter.coffee"
position   = require "../../../core/methods/font/position.coffee"
rendering  = require "../../../core/methods/rendering.coffee"
transform  = require "../../../core/methods/font/transform.coffee"

module.exports = (axis) ->
  accepted:   [Array, Boolean, Function, Object, String]
  axis:
    color:     "#444"
    font:
      color:      "#444"
      decoration: decoration()
      family:     family()
      size:       10
      transform:  transform()
      weight:     200
    rendering: rendering()
  dataFilter: true
  deprecates: [axis + "axis", axis + "axis_val", axis + "axis_var"]
  domain:
    accepted: [false, Array]
    value:    false
  grid:
    color:     "#ccc"
    rendering: rendering()
  label:
    color:      "#444"
    decoration: decoration()
    family:     family()
    size:       12
    transform:  transform()
    weight:     200
  lines:
    accept:    [false, Array, Number, Object]
    dasharray:
      accepted: [Array, String]
      process: (value) ->
        if value instanceof Array
          value = value.filter (d) -> !isNaN(d)
          value = if value.length then value.join(", ") else "none"
        value
      value: "10, 10"
    color:     "#888"
    font:
      align: align("right")
      color:      "#444"
      background:
        accepted: [Boolean]
        value:    true
      decoration: decoration()
      family:     family()
      padding:
        accepted: [Number]
        value:    10
      position:   position("middle")
      size:       12
      transform:  transform()
      weight:     200
    process:   Array
    rendering: rendering()
    width:     1
    value:     []
  mouse:
    accept:    [Boolean]
    dasharray:
      accepted: [Array, String]
      process: (value) ->
        if value instanceof Array
          value = value.filter (d) -> !isNaN(d)
          value = if value.length then value.join(", ") else "none"
        value
      value: "none"
    rendering: rendering()
    width:     2
    value:     true
  mute:  filter(true)
  range:
    accepted: [false, Array]
    value:    false
  scale:
    accepted:   ["linear", "log", "discrete", "share"]
    deprecates: ["layout", "unique_axis", axis + "axis_scale"]
    process:    (value, vars) ->
      for scale in ["log", "discrete", "share"]
        if scale is value
          vars.axes[scale] = axis
        else vars.axes[scale] = false if vars.axes[scale] is axis
      vars.axes.opposite = (if axis is "x" then "y" else "x") if value is "discrete"
      value
    value: "linear"
  solo:    filter(true)
  stacked:
    accepted: [Boolean]
    process:  (value, vars) ->
      if not value and vars.axes.stacked is axis
        vars.axes.stacked = false
      else vars.axes.stacked = axis if value
      value
    value: false
  ticks:
    color:     "#ccc"
    font:
      color:      "#666"
      decoration: decoration()
      family:     family()
      size:       10
      transform:  transform()
      weight:     200
    rendering: rendering()
    size:      10
    width:     1
  value:    false
  zerofill:
    accepted: [Boolean]
    value:    false
